//***************************************************************************
//  Genetic Algorithm Viewer 1.0
//    26/5/2000
//
//  This program uses a GA to find a Biomorph Genome
//    Jean-Philippe Rennard May 2000
//    alife@rennard.org
//    http://www.rennard.org/alife
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package Gav;

import java.awt.*;
import java.util.*;
/** CUniverse : Abstract class to define universe Basic properties */
abstract class CUniverse
{
  static final int BIOTS_BKP_SIZE=20;
  /** Pointer to Application */
  Container MyApp;

  final int NbDirections=8;
  /** Biots Collection */
  Vector Biots;
  /** 2d Biots Collection for diverses uses */
  Stack BiotsBkp;
  /** Constructor */
  public CUniverse(Container app) {
    MyApp=app;
    Biots=new Vector();
    BiotsBkp=new Stack();
  }
  /** Return the nth Biot in Collection */
  public CBiot GetBiotAt(int n) {
    return((CBiot)Biots.elementAt(n));
  }
  /** Add a Biot to BKP */
  public void AddBiotBkp(CBiot b) {

    if(BiotsBkp.size()==BIOTS_BKP_SIZE) {
      CBiot bl[];
      bl=new CBiot[BIOTS_BKP_SIZE];
      for(int i=0;i<BIOTS_BKP_SIZE;i++)
        bl[i]=(CBiot)BiotsBkp.pop();
      for(int i=BIOTS_BKP_SIZE-2;i>=0;i--)
          BiotsBkp.push(bl[i]);
    }
    BiotsBkp.push(b);
  }
  /** Remove a Biot from BKP */
  public void RemoveBiotBkp() {
    BiotsBkp.pop();
  }
  /** Empty BiotBkp */
  public void EmptyBiotBkp() {
    BiotsBkp.removeAllElements();
  }
  /** Get Last Biot in BKP */
  public CBiot GetBiotBkp() {
    return( (CBiot) BiotsBkp.peek() );
  }
  /** Run the World */
  abstract public void Go(JPView jpv);
  /** Draw the World */
  abstract public void DrawWorld(JPView jpv);
}


