//***************************************************************************
//  JPView 1.0
//    10/1/2000
//
//    Jean-Philippe Rennard
//    alife@rennard.org
//    http://www.rennard.org/alife/
//
// Views. Gives a Canvas to a panel and
// manages sizing and double buffering.
// To use this class, just create inheriting classes for each canvas you need
// and define only the paint function (optionnaly a constructor to
// initiate background color.)
//***************************************************************************
package Gav;

import java.awt.*;
import java.awt.event.*;
//***************************************************************************
/** JPView : Views. Gives a Canvas to a panel and
manages sizing and double buffering.
To use this class, just create inheriting classes for each canvas you need
and define only the paint function (optionnaly a constructor to
initiate background color.) */

class JPView extends Canvas
{
  /** Image for double buffering */
  Image ImgBuff;
  /** Graphics context for double buffering */
  Graphics GrBuff;
  /** View size **/
  int Height,Width;
  /** Logical size for calculation */
  float lHeight, lWidth;
  /** Default constructor */
  public JPView() {
  }
  /** Construct a View with a bkgrd color */
  public JPView(Color c) {
    setBackground(c);
    setForeground(Color.white);
  }
    /** remove buffer */
  public void destroy() {
    GrBuff.dispose();
  }

  /** Set the dimension variables, returns the Dimension */
  Dimension SetDim() {
    Dimension d=getParent().getSize();
    Height=d.height;
    Width=d.width;
    return(d);
  }
  /** Set the logical size */
  void SetLogicalSize(float w,float h) {
    lWidth=w;
    lHeight=h;
  }
  /** Modify the size of the view */
  void ResizeGrBuff() {
    SetDim();
    ImgBuff=null;
    ImgBuff=createImage(Width,Height);
    GrBuff=ImgBuff.getGraphics();
  }
  /** Clear Background. WNG : doesn't manage repaint to limit multiple calls. */
  void ClearBkg() {
    GrBuff.setColor(getBackground());
    GrBuff.fillRect(0,0,Width,Height);
    GrBuff.setColor(this.getForeground());
  }

  public void repaint() {
    paint(this.getGraphics());
  }
  public void paint(Graphics g) {
    if(ImgBuff!=null)
      g.drawImage(ImgBuff,0,0,this);
  }
}
